unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, 
  StdCtrls, Db, ExtCtrls, Spin, EBatTab, DBClient;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label1: TLabel;
    BtnTabela: TButton;
    BtnArquivo: TButton;
    EdtTabela: TEdit;
    EdtArquivo: TEdit;
    GroupBox2: TGroupBox;
    LabSeparador: TLabel;
    Label4: TLabel;
    LabDecimais: TLabel;
    LabDigitos: TLabel;
    EdtSeparador: TEdit;
    ChkBoxSeparador: TCheckBox;
    ChkBoxSobrescrever: TCheckBox;
    MemoCampos: TMemo;
    ChkBoxZeros: TCheckBox;
    SpEdtDecimais: TSpinEdit;
    SpEdtDigitos: TSpinEdit;
    BtnProcessar: TButton;
    RGrpOperacao: TRadioGroup;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    BatchTable1: TEvBatchTable;
    ClientDataSet1: TClientDataSet;
    procedure BtnTabelaClick(Sender: TObject);
    procedure BtnArquivoClick(Sender: TObject);
    procedure ChkBoxSeparadorClick(Sender: TObject);
    procedure EdtArquivoChange(Sender: TObject);
    procedure BtnProcessarClick(Sender: TObject);
    procedure BatchTable1Error(Sender: TObject; Error: TEvBatchError);
    procedure EdtTabelaChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BtnTabelaClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    EdtTabela.Text := OpenDialog1.FileName;
end;

procedure TForm1.BtnArquivoClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    EdtArquivo.Text := SaveDialog1.FileName;
end;

procedure TForm1.ChkBoxSeparadorClick(Sender: TObject);
begin
  LabSeparador.Enabled := ChkBoxSeparador.Checked;
  EdtSeparador.Enabled := ChkBoxSeparador.Checked;
  LabDecimais.Enabled := not ChkBoxSeparador.Checked;
  LabDigitos.Enabled := not ChkBoxSeparador.Checked;
  SpEdtDecimais.Enabled := not ChkBoxSeparador.Checked;
  SpEdtDigitos.Enabled := not ChkBoxSeparador.Checked;
  ChkBoxZeros.Enabled := not ChkBoxSeparador.Checked;
  if ChkBoxSeparador.Checked then
    begin
      EdtSeparador.Color := clWindow;
      SpEdtDecimais.Color := clBtnFace;
      SpEdtDigitos.Color := clBtnFace;
      EdtSeparador.SetFocus;
    end
  else
    begin
      EdtSeparador.Color := clBtnFace;
      SpEdtDecimais.Color := clWindow;
      SpEdtDigitos.Color := clWindow;
      SpEdtDecimais.SetFocus;
    end;
end;

procedure TForm1.EdtTabelaChange(Sender: TObject);
var
  I: Integer;
begin
  EdtArquivoChange(Sender);
  ClientDataSet1.FileName := EdtTabela.Text;
  try
    ClientDataSet1.Open;
    MemoCampos.Clear;
    for I := 0 to ClientDataSet1.FieldDefs.Count - 1 do
      MemoCampos.Lines.Add(ClientDataSet1.Fields[I].FieldName);
    ClientDataSet1.Close;
  except
    ShowMessage('No foi possvel abrir a tabela especificada.');
  end;
end;

procedure TForm1.EdtArquivoChange(Sender: TObject);
begin
  BtnProcessar.Enabled := (EdtTabela.Text <> '') and
    (EdtArquivo.Text <> '');
end;

procedure TForm1.BtnProcessarClick(Sender: TObject);
begin
  case RGrpOperacao.ItemIndex of
    0: BatchTable1.Action := baExport;
    1: BatchTable1.Action := baImport;
  end;
  if ChkBoxSeparador.Checked then
    BatchTable1.DataDelimiter := EdtSeparador.Text[1]
  else
    begin
      BatchTable1.DataDelimiter := #0;
      BatchTable1.DecLength := Round(SpEdtDecimais.Value);
      BatchTable1.NumLength := Round(SpEdtDigitos.Value);
      BatchTable1.FillZero := ChkBoxZeros.Checked;
    end;
  BatchTable1.Fields.Assign(MemoCampos.Lines);
  BatchTable1.FileName := EdtArquivo.Text;
  BatchTable1.Overwrite := ChkBoxSobrescrever.Checked;
  if BatchTable1.Execute then
    ShowMessage('Operao concluda com sucesso.');
end;

procedure TForm1.BatchTable1Error(Sender: TObject; Error: TEvBatchError);
var
  S: string;
begin
  case Error of
    beOpenSource: S := 'No foi possvel abrir a tabela.';
    beOverwrite: S := 'O arquivo de destino j existe e no pode ser sobrescrito.';
    beCreateFile: S := 'O arquivo de destino no pode ser criado.';
    beOpenFile: S := 'O arquivo de importao no pode ser aberto.';
    beAppendReg: S := 'Erro ao adicionar registros na tabela.';
    beWriteFile: S := 'Erro ao gravar no arquivo de destino.';
  end;
  ShowMessage(S);
end;


end.
